/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: chip_config.h 1067 2014-12-24 14:15:10Z ertl-honda $
 */

/*
 *  åװ¸⥸塼MPCOREѡ
 *
 *  ͥΥåװ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_CHIP_CONFIG_H
#define TOPPERS_CHIP_CONFIG_H

/*
 *  åװ¸ΤΥϡɥ񸻤
 */
#include "mpcore.h"

#ifdef USE_IPI_DIS_HANDER_BYPASS
#define OMIT_KER_REQ_ON_IPI

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ͥ뽪λ׵
 */
extern void ext_ker_request(void);
#endif /* TOPPERS_MACRO_ONLY */
#endif /* USE_IPI_DIS_HANDER_BYPASS */

/*
 *  ֹΥޥʲ16bitΤߤͭ
 */
#define INTNO_MASK(intno) (intno & 0xffffU)

/*
 *  ֹ³ץåΥץåIDʾ16bit
 */
#define INTNO_PRCID(intno) (intno >> 16U)

/*
 *  ߥϥɥֹΥޥʲ16bitΤߤͭ
 */
#define INHNO_MASK(intno) (intno & 0xffffU)

/*
 *  ߥϥɥֹȳֹ˴ؤ
 */
#define TMIN_INTNO  DIC_TMIN_INTNO
#define TMAX_INTNO  DIC_TMAX_INTNO
#define TNUM_INT    DIC_TNUM_INT

#define TMIN_INHNO  DIC_TMIN_INTNO
#define TMAX_INHNO  DIC_TMAX_INTNO
#define TNUM_INH    DIC_TNUM_INT

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåAPCBؤΥݥ󥿤μ
 *  󥯥롼ɽδط塤target_pcb.h ˤϵҤǤʤᤳ롥
 */
Inline APCB*
get_my_p_apcb(void)
{
	return &((get_my_p_tpcb())->arm_pcb);
}

/*
 *  ޥץå֤
 */
Inline bool_t
x_sense_mprc(void){
	if(x_prc_index() == (TOPPERS_MASTER_PRCID - 1)) {
		return true;
	}
	else {
		return false;
	}
}

/*
 *  åط
 */

/*
 *  㥤ȥåνG_LOCKξ
 */
Inline void
x_initialize_giant_lock(LOCK *p_giant_lock)
{
	*p_giant_lock = 0;
}

/*
 *  åν
 */
Inline void
x_initialize_tsk_lock(LOCK *p_tsk_lock)
{
	*p_tsk_lock = 0;
}

/*
 *  ֥ȥåν
 */
Inline void
x_initialize_obj_lock(LOCK *p_obj_lock)
{
	*p_obj_lock = 0;
}

/*
 *  ֹϰϤȽ
 */
#if TMIN_INTNO == 0
#define VALID_INTNO(prcid, intno) ((INTNO_MASK(intno) <= TMAX_INTNO) \
                                    && (INTNO_PRCID(intno) == 0U || INTNO_PRCID(intno) == prcid))
#else /* !TMIN_INTNO == 0 */
#define VALID_INTNO(prcid, intno) (((TMIN_INTNO <= (INTNO_MASK(intno)) && (INTNO_MASK(intno)) <= TMAX_INTNO)) \
                                    && (INTNO_PRCID(intno) == 0U || INTNO_PRCID(intno) == prcid))
#endif /* TMIN_INTNO == 0 */

#define VALID_INTNO_DISINT(prcid, intno)	VALID_INTNO(prcid, intno)
#define VALID_INTNO_CFGINT(prcid, intno)	VALID_INTNO(prcid, intno)

/*
 *  ߥϥɥϿѥơ֥kernel_cfg.c
 */
extern const FP* const p_inh_table[TNUM_PRCID];

/*
 *  ߥϥɥ
 *
 *  ߥϥɥֹinhnoγߥϥɥεưϤinthdrꤹ
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry, uint_t affinity_mask)
{
#if TMIN_INTNO == 0
		assert((INHNO_MASK(inhno) <= TMAX_INHNO));
#else /* !TMIN_INTNO == 0 */
	assert(((TMIN_INHNO <= INHNO_MASK(inhno)) && (INHNO_MASK(inhno) <= TMAX_INHNO)));
#endif /* TMIN_INTNO == 0 */
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ͥ٥ޥ饤֥
 *
 *  DICǤϡDICͥ٥쥸CPUγͥ٥ޥIPMˤꤹ롥
 *  ͥ٥ޥͤ礭ۤͥ٤Ǥ롥
 *  ͥ٥ޥϤʳARM11CA9ǰۤʤ롥
 *    ARM11(ARMv6) : 16ʳ0x00  0x0f
 *    CA9(ARMv7)   : 32ʳ0x00  0x1f
 *  IPM¸Ƥˡͥ٤γɽ-1Ϣ³͡
 *  ȤȤǽǤ뤬;פʷ׻ɬפˤʤ롥򤱤뤿ᡤIPM
 *  ¸ˤϡDICǰͥ٤ηȤ롥ͤͥ٥ޥ
 *  ɽȸƤӡIIPMȽ񤯤Ȥˤ롥
 */

/*
 *  ͥ٥ޥΥӥåȥޥ
 */
#if __TARGET_ARCH_ARM == 6
#ifndef TOPPERS_MACRO_ONLY
#define IPM_BIT_MASK  0x0fU
#else /* TOPPERS_MACRO_ONLY */
#define IPM_BIT_MASK  0x0f
#endif /* TOPPERS_MACRO_ONLY */
#define IPM_BIT_OFFSET 4
#elif __TARGET_ARCH_ARM == 7
#ifndef TOPPERS_MACRO_ONLY
#define IPM_BIT_MASK  0x1fU
#else /* TOPPERS_MACRO_ONLY */
#define IPM_BIT_MASK  0x1f
#endif /* TOPPERS_MACRO_ONLY */
#define IPM_BIT_OFFSET 3
#endif /* __TARGET_ARCH_ARM == 7 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡ
 *  㥹ȤʤѰդƤ롥
 */
#ifndef TOPPERS_MACRO_ONLY
#define EXT_IPM(iipm)    ((PRI)(iipm - IPM_BIT_MASK))    /* ɽɽ */
#define INT_IPM(ipm)    ((uint8_t)(ipm + IPM_BIT_MASK))  /* ɽɽ */
#else /* TOPPERS_MACRO_ONLY */
#define EXT_IPM(iipm)    (iipm - IPM_BIT_MASK)           /* ɽɽ */
#define INT_IPM(ipm)    (ipm + IPM_BIT_MASK)             /* ɽɽ */
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL        (INT_IPM(TIPM_ENAALL))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint8_t
current_iipm(void)
{
	return(dic_cpu_current_priority());
}

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint8_t iipm)
{
	dic_cpu_set_priority(iipm);
}

#endif /* TOPPERS_MACRO_ONLY */

#ifdef USE_GIC_CPULOCK

/*
 *  USE_GIC_CPULOCK
 */

#define IIPM_LOCK 0x00

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ƥȤλ(USE_GIC_CPULOCK)
 *
 *  ARMǤϡƥȤ󥿥ƥȤξ򥹡ѡ
 *  Х⡼ɤư롥ΤᡤCPSRƤǤȽ̤Ǥʤ
 *  Τᡤ㳰ʳ/CPU㳰ˤΥͥȲ򥫥Ȥѿ
 *  excpt_nest_countˤѰդ㳰ǥ󥯥Ȥ뤳
 *  ǡƥȤȽꤹ롥
 */
Inline bool_t
sense_context(void)
{
	uint32_t tmp;
	uint8_t saved_iipm;
	APCB* my_p_apcb;

	/*
	 *  ޥ졼󤵤뤳ȤθƳߤػߤƤ
	 *  롥
	 */
	saved_iipm = current_iipm();
	set_iipm(IIPM_LOCK);
	ARM_MEMORY_CHANGED;
	my_p_apcb = get_my_p_apcb();
	tmp = my_p_apcb->excpt_nest_count;
	set_iipm(saved_iipm);
	ARM_MEMORY_CHANGED;

	return(tmp > 0U);
}

/*
 *  CPUå֤ؤΰܹ(USE_GIC_CPULOCK)
 *
 *  IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *  ͥΤΤ٤Ƥγߤޥ͡TIPM_LOCKˤ
 *  ꤹ롥ޤlock_flagtrueˤ롥
 *
 *  IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *  saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϥǥ
 *  γͥ٥ޥTIPM_LOCKƱ⤤٥
 *  Ƥ֤ˤ롥
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *  ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
	uint8_t iipm;

	/*
	*  current_iipm()֤ͤľsaved_iipm¸ѿiipm
	*  ѤƤΤϡcurrent_iipm()Ƥľ˳ߤȯ
	*  ư줿߽saved_iipmѹǽ뤿
	*  롥
	*/
	iipm = current_iipm();
	set_iipm(IIPM_LOCK);
	get_my_p_tpcb()->saved_iipm = iipm;
	get_my_p_tpcb()->lock_flag = true;

	/* ƥ륻ǥ꤬񤭴ǽ */
	ARM_MEMORY_CHANGED;
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β(USE_GIC_CPULOCK)
 *
 *  lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *  saved_iipm¸᤹ͤ
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *  ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	ARM_MEMORY_CHANGED;
	get_my_p_tpcb()->lock_flag = false;
	set_iipm(get_my_p_tpcb()->saved_iipm);
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUå֤λ(USE_GIC_CPULOCK)
 */
Inline bool_t
x_sense_lock(void)
{
	return(get_my_p_tpcb()->lock_flag);
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()


/*
 * ʥǥΡ˳ͥ٥ޥ(USE_GIC_CPULOCK)
 *
 *  CPUåե饰ꥢƤϡϡɥγͥ٥
 *  ꤹ롥CPUåե饰åȤƤϡsaved_iipm
 *  ꤷˡϡɥγͥ٥ޥꤷ褦
 *  ʥǥΡ˳ͥ٥ޥTIPM_LOCKι⤤ꤹ롥
 */
Inline void
x_set_ipm(PRI intpri)
{
	uint8_t   iipm = INT_IPM(intpri);

	if (!get_my_p_tpcb()->lock_flag) {
		set_iipm(iipm);
	}
	else {
		get_my_p_tpcb()->saved_iipm = iipm;
		/*
		 *  OS⤫Τ߸ƤӽФ뤿ᡤλǥϡɥγͥ
		 *  ٥ޥɬͤꤵƤ뤿ᡤꤹɬפϤʤ
		 */
	}
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ(USE_GIC_CPULOCK)
 *
 *  CPUåե饰ꥢƤϥϡɥγͥ٥
 *  򡤥åȤƤsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
	uint8_t iipm;

	if (!get_my_p_tpcb()->lock_flag) {
		iipm = current_iipm();
	}
	else {
		iipm = get_my_p_tpcb()->saved_iipm;
	}
	return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  CPU㳰ȯ(ǥ)ͥ٥ޥλ(USE_GIC_CPULOCK)
 */
Inline PRI
exc_get_ipm(void *p_excinf)
{
	if (!((exc_frame_t *)(p_excinf))->lock_flag) {
		return((PRI)(((exc_frame_t *)(p_excinf))->ipm));
	}
	else {
		return((PRI)(((exc_frame_t *)(p_excinf))->saved_iipm));
	}
}

/*
 * CPUå֤(USE_GIC_CPULOCK)
 */
Inline bool_t
exc_sense_lock(void *p_excinf)
{
	return(((exc_frame_t *)(p_excinf))->lock_flag);
}

/*
 * ߥå֤(USE_GIC_CPULOCK)
 */
Inline bool_t
exc_sense_int_lock(void *p_excinf)
{
	return(((exc_frame_t *)(p_excinf))->lock_flag);
}

#endif /* TOPPERS_MACRO_ONLY */

#else /* USE_GIC_CPULOCK */

#ifndef TOPPERS_MACRO_ONLY

/*
 * (ǥ)ͥ٥ޥ
 */
Inline void
x_set_ipm(PRI intpri)
{
	set_iipm(INT_IPM(intpri));
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 */
Inline PRI
x_get_ipm(void)
{
	return(EXT_IPM(current_iipm()));
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

#endif /* TOPPERS_MACRO_ONLY */

#endif /* USE_GIC_CPULOCK */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  °ơ֥
 *
 *  °ơ֥ؤΥݥ󥿡°ơ֥ϡ°
 *  Ƥ"1"ꤵƤʤ"0"Ȥʤ
 */
extern const uint8_t* const p_cfgint_table[];

#define my_cfgint_table (p_cfgint_table[x_prc_index()])

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	if (my_cfgint_table[INTNO_MASK(intno)] == 0){
		return(false);
	}

	dic_disable_int(INTNO_MASK(intno));
	return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/*
 *  (ǥ)׵ػߥե饰β
 *
 *  ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 *  Ĥ롥
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	if (my_cfgint_table[INTNO_MASK(intno)] == 0){
		return(false);
	}

	dic_enable_int(INTNO_MASK(intno));
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
	dic_clear_pending(INTNO_MASK(intno));
}

#define t_clear_int(intno) x_clear_int(intno)
#define i_clear_int(intno) x_clear_int(intno)

/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	return(dic_probe_int(INTNO_MASK(intno)));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 *
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask);

/*
 * ߥϥɥɬפIRC
 *
 */
Inline void
i_begin_int(INTNO intno)
{
}

/*
 * ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  str_ker() ǥޥץåǹԤ
 */
extern void chip_mprc_initialize(void);

/*
 *  åװ¸ν
 */
extern void chip_initialize(void);

/*
 *  åװ¸νλ
 *
 *  ƥλ˻Ȥ
 */
extern void chip_exit(void);

/*
 *  ߥϥɥchip_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ARM¸⥸塼
 */
#include "arm_gcc/common/core_config.h"

/*
 *  åװ¸⥸塼Υġ¸
 */
#include <chip_config_tool.h>

#endif /* TOPPERS_CHIP_CONFIG_H */
